const { BrowserWindow, app } = require('electron')
var jetpack = require('fs-jetpack');
var request = require('request');
var fs = require('fs');

exports.version = function() {
    console.log("ElectronJSXP v.1.0.0");
}
exports.download = function(url, path, textidtoshowpercent) {
    var received_bytes = 0;
    var total_bytes = 0;

    var req = request({
        method: 'GET',
        uri: url
    });

    var out = fs.createWriteStream(path);
    req.pipe(out);

    req.on('response', function ( data ) {
        // Change the total bytes value to get progress later.
        total_bytes = parseInt(data.headers['content-length' ]);
    });

    req.on('data', function(chunk) {
        // Update the received bytes
        received_bytes += chunk.length;

        showProgress(received_bytes, total_bytes, textidtoshowpercent);
    });
}

function showProgress(received, total, objectid){
    var percentage = (received * 100) / total;
    console.log(percentage + "% | " + received + " bytes out of " + total + " bytes.");
    document.getElementById(objectid).textContent = Math.round((received * 100) / total) + "%";
}

exports.json_write = function(data, path) {
    jetpack.write(path, data);
}

exports.json_read = function(path) {
    return jetpack.read(path);
}

exports.text_write = function(data, path) {
    jetpack.write(path, data);
}

exports.text_read = function(path) {
    return jetpack.read(path);
}

exports.html_setattribute = function(id, attribute, value) {
    document.getElementById(id).setAttribute(attribute, value);
}

exports.html_removeattribute = function(id, attribute) {
    document.getElementById(id).removeAttribute(attribute);
}

exports.html_enableobject = function(id) {
    document.getElementById(id).setAttribute("disabled", "true");
}

exports.html_disableobject = function(id) {
    document.getElementById(id).removeAttribute("disabled");
}

exports.redirect_noback = function(url) {
    window.location.replace(url);
}

exports.redirect = function(url) {
    window.location.href = url;
}

exports.getAppData = function() {
    return "Name: " + app.getName() + ", version: " + app.getVersion;
}

exports.getAppPath = function() {
    return app.getPath();
}

exports.overridePath = function(path) {
    app.setPath(app.getName(), path);
}

exports.exit = function() {
    app.quit()
}

exports.test = function() {
    console.log("ElectronJSXP v.1.0.0 by StopperTech. Advanced Electron Tools.");
    console.log("If you see this, ElectronJSXP is working fine!");
}